diff -rN -u old-cl-objc/src/cffi.lisp new-cl-objc/src/cffi.lisp
--- old-cl-objc/src/cffi.lisp	2008-05-06 19:18:48.000000000 -0400
+++ new-cl-objc/src/cffi.lisp	2008-05-06 19:18:48.000000000 -0400
@@ -1,4 +1,5 @@
 (in-package "OBJC-CFFI")
+;(declaim (optimize (speed 0) (space 0) (compilation-speed 0) (safety 3) (debug 3)))
 
 ;;; Load Foreign libraries
 
@@ -483,20 +484,22 @@
 				      ivars methodlists
 				      cache protocols)
 				 class-ptr objc-class-cstruct)
-	      (setf (gethash (append info (list name)) *objc-classes*)
-		    (make-instance 'objc-class
-				   :isa (unless (pointer-eq isa class-ptr) 
-					  (convert-from-foreign isa 'objc-class-pointer))
-				   :super-class super_class 
-				   :name name
-				   :version version 
-				   :info info 
-				   :instance-size instance_size
-				   :ivars ivars 
-				   :method-lists methodlists ; FIXME: i d like to convert it
-				   :cache cache 
-				   :protocols protocols
-				   :ptr class-ptr)))))
+	      (let ((class (make-instance 'objc-class
+					  :isa (unless (pointer-eq isa class-ptr) 
+						 (convert-from-foreign isa 'objc-class-pointer))
+					  :super-class super_class 
+					  :name name
+					  :version version 
+					  :info info 
+					  :instance-size instance_size
+					  :ivars ivars 
+					  :method-lists methodlists ; FIXME: i d like to convert it
+					  :cache cache 
+					  :ptr class-ptr)))
+		(setf (gethash (append info (list name)) *objc-classes*)
+		      class)
+		(setf (slot-value class 'protocols) protocols)
+		class))))
       objc-nil-class))
 
 ;; See the objc-class-cstruct definition to know about the aim of this method 
diff -rN -u old-cl-objc/src/msg-send.lisp new-cl-objc/src/msg-send.lisp
--- old-cl-objc/src/msg-send.lisp	2008-05-06 19:18:48.000000000 -0400
+++ new-cl-objc/src/msg-send.lisp	2008-05-06 19:18:48.000000000 -0400
@@ -1,4 +1,5 @@
 (in-package "OBJC-CFFI")
+;(declaim (optimize (speed 0) (space 0) (compilation-speed 0) (safety 3) (debug 3)))
 
 ;;; Method calls
 
diff -rN -u old-cl-objc/src/structs.lisp new-cl-objc/src/structs.lisp
--- old-cl-objc/src/structs.lisp	2008-05-06 19:18:48.000000000 -0400
+++ new-cl-objc/src/structs.lisp	2008-05-06 19:18:48.000000000 -0400
@@ -237,10 +237,10 @@
 
 (defun objc-struct-slot-value (ptr type slot-name)
   "Return the value of SLOT-NAME in the ObjC Structure TYPE at PTR."
-  (cffi:foreign-slot-value (coerce ptr 'cffi:foreign-pointer) type slot-name))
+  (cffi:foreign-slot-value ptr type slot-name))
 
 (defun set-objc-struct-slot-value (ptr type slot-name newval)
-  (setf (cffi:foreign-slot-value (coerce ptr 'cffi:foreign-pointer) type slot-name) newval))
+  (setf (cffi:foreign-slot-value ptr type slot-name) newval))
 
 (defsetf objc-struct-slot-value set-objc-struct-slot-value)
 

